/**
 * The MIT License (MIT)
 *
 * Copyright (c) 2019 Erik Moqvist
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/**
 * This file was generated by pbtools.
 */

#include <limits.h>
#include "ordering.h"

#if CHAR_BIT != 8
#    error "Number of bits in a char must be 8."
#endif

void ordering_bar_fie_init(
    struct ordering_bar_fie_t *self_p,
    struct pbtools_heap_t *heap_p,
    struct ordering_bar_fie_t *next_p)
{
    self_p->base.heap_p = heap_p;
    self_p->base.next_p = &next_p->base;
    self_p->v1 = 0;
    self_p->v2 = 0;
}

void ordering_bar_fie_encode_inner(
    struct pbtools_encoder_t *encoder_p,
    struct ordering_bar_fie_t *self_p)
{
    pbtools_encoder_write_enum(encoder_p, 2, self_p->v2);
    pbtools_encoder_write_bool(encoder_p, 1, self_p->v1);
}

void ordering_bar_fie_decode_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_fie_t *self_p)
{
    int wire_type;

    while (pbtools_decoder_available(decoder_p)) {
        switch (pbtools_decoder_read_tag(decoder_p, &wire_type)) {

        case 1:
            self_p->v1 = pbtools_decoder_read_bool(decoder_p, wire_type);
            break;

        case 2:
            self_p->v2 = pbtools_decoder_read_enum(decoder_p, wire_type);
            break;

        default:
            pbtools_decoder_skip_field(decoder_p, wire_type);
            break;
        }
    }
}

void ordering_bar_fie_encode_repeated_inner(
    struct pbtools_encoder_t *encoder_p,
    int field_number,
    struct ordering_bar_fie_repeated_t *repeated_p)
{
    pbtools_encode_repeated_inner(
        encoder_p,
        field_number,
        (struct pbtools_repeated_message_t *)repeated_p,
        (pbtools_message_encode_inner_t)ordering_bar_fie_encode_inner);
}

void ordering_bar_fie_decode_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct ordering_bar_fie_repeated_t *repeated_p)
{
    pbtools_decode_repeated_inner(
        decoder_p,
        wire_type,
        (struct pbtools_repeated_message_t *)repeated_p,
        sizeof(struct ordering_bar_fie_t),
        (pbtools_message_init_t)ordering_bar_fie_init,
        (pbtools_message_decode_inner_t)ordering_bar_fie_decode_inner);
}

void ordering_bar_fie_finalize_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_fie_repeated_t *repeated_p)
{
    pbtools_finalize_repeated_inner(
        decoder_p,
        (struct pbtools_repeated_message_t *)repeated_p);
}

void ordering_bar_gom_init(
    struct ordering_bar_gom_t *self_p,
    struct pbtools_heap_t *heap_p,
    struct ordering_bar_gom_t *next_p)
{
    self_p->base.heap_p = heap_p;
    self_p->base.next_p = &next_p->base;
    ordering_bar_fie_init(&self_p->v1, heap_p, NULL);
}

void ordering_bar_gom_encode_inner(
    struct pbtools_encoder_t *encoder_p,
    struct ordering_bar_gom_t *self_p)
{
    pbtools_encoder_sub_message_encode(
        encoder_p,
        1,
        &self_p->v1.base,
        (pbtools_message_encode_inner_t)ordering_bar_fie_encode_inner);
}

void ordering_bar_gom_decode_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_gom_t *self_p)
{
    int wire_type;

    while (pbtools_decoder_available(decoder_p)) {
        switch (pbtools_decoder_read_tag(decoder_p, &wire_type)) {

        case 1:
            pbtools_decoder_sub_message_decode(
                decoder_p,
                wire_type,
                &self_p->v1.base,
                (pbtools_message_decode_inner_t)ordering_bar_fie_decode_inner);
            break;

        default:
            pbtools_decoder_skip_field(decoder_p, wire_type);
            break;
        }
    }
}

void ordering_bar_gom_encode_repeated_inner(
    struct pbtools_encoder_t *encoder_p,
    int field_number,
    struct ordering_bar_gom_repeated_t *repeated_p)
{
    pbtools_encode_repeated_inner(
        encoder_p,
        field_number,
        (struct pbtools_repeated_message_t *)repeated_p,
        (pbtools_message_encode_inner_t)ordering_bar_gom_encode_inner);
}

void ordering_bar_gom_decode_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct ordering_bar_gom_repeated_t *repeated_p)
{
    pbtools_decode_repeated_inner(
        decoder_p,
        wire_type,
        (struct pbtools_repeated_message_t *)repeated_p,
        sizeof(struct ordering_bar_gom_t),
        (pbtools_message_init_t)ordering_bar_gom_init,
        (pbtools_message_decode_inner_t)ordering_bar_gom_decode_inner);
}

void ordering_bar_gom_finalize_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_gom_repeated_t *repeated_p)
{
    pbtools_finalize_repeated_inner(
        decoder_p,
        (struct pbtools_repeated_message_t *)repeated_p);
}

void ordering_bar_init(
    struct ordering_bar_t *self_p,
    struct pbtools_heap_t *heap_p,
    struct ordering_bar_t *next_p)
{
    self_p->base.heap_p = heap_p;
    self_p->base.next_p = &next_p->base;
    self_p->value = 0;
    ordering_bar_fie_init(&self_p->fie, heap_p, NULL);
    self_p->fum = 0;
    ordering_bar_gom_init(&self_p->gom, heap_p, NULL);
}

void ordering_bar_encode_inner(
    struct pbtools_encoder_t *encoder_p,
    struct ordering_bar_t *self_p)
{
    pbtools_encoder_sub_message_encode(
        encoder_p,
        4,
        &self_p->gom.base,
        (pbtools_message_encode_inner_t)ordering_bar_gom_encode_inner);
    pbtools_encoder_write_enum(encoder_p, 3, self_p->fum);
    pbtools_encoder_sub_message_encode(
        encoder_p,
        2,
        &self_p->fie.base,
        (pbtools_message_encode_inner_t)ordering_bar_fie_encode_inner);
    pbtools_encoder_write_bool(encoder_p, 1, self_p->value);
}

void ordering_bar_decode_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_t *self_p)
{
    int wire_type;

    while (pbtools_decoder_available(decoder_p)) {
        switch (pbtools_decoder_read_tag(decoder_p, &wire_type)) {

        case 1:
            self_p->value = pbtools_decoder_read_bool(decoder_p, wire_type);
            break;

        case 2:
            pbtools_decoder_sub_message_decode(
                decoder_p,
                wire_type,
                &self_p->fie.base,
                (pbtools_message_decode_inner_t)ordering_bar_fie_decode_inner);
            break;

        case 3:
            self_p->fum = pbtools_decoder_read_enum(decoder_p, wire_type);
            break;

        case 4:
            pbtools_decoder_sub_message_decode(
                decoder_p,
                wire_type,
                &self_p->gom.base,
                (pbtools_message_decode_inner_t)ordering_bar_gom_decode_inner);
            break;

        default:
            pbtools_decoder_skip_field(decoder_p, wire_type);
            break;
        }
    }
}

void ordering_bar_encode_repeated_inner(
    struct pbtools_encoder_t *encoder_p,
    int field_number,
    struct ordering_bar_repeated_t *repeated_p)
{
    pbtools_encode_repeated_inner(
        encoder_p,
        field_number,
        (struct pbtools_repeated_message_t *)repeated_p,
        (pbtools_message_encode_inner_t)ordering_bar_encode_inner);
}

void ordering_bar_decode_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct ordering_bar_repeated_t *repeated_p)
{
    pbtools_decode_repeated_inner(
        decoder_p,
        wire_type,
        (struct pbtools_repeated_message_t *)repeated_p,
        sizeof(struct ordering_bar_t),
        (pbtools_message_init_t)ordering_bar_init,
        (pbtools_message_decode_inner_t)ordering_bar_decode_inner);
}

void ordering_bar_finalize_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_bar_repeated_t *repeated_p)
{
    pbtools_finalize_repeated_inner(
        decoder_p,
        (struct pbtools_repeated_message_t *)repeated_p);
}

struct ordering_bar_t *
ordering_bar_new(
    void *workspace_p,
    size_t size)
{
    return (pbtools_message_new(
                workspace_p,
                size,
                sizeof(struct ordering_bar_t),
                (pbtools_message_init_t)ordering_bar_init));
}

int ordering_bar_encode(
    struct ordering_bar_t *self_p,
    uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_encode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_encode_inner_t)ordering_bar_encode_inner));
}

int ordering_bar_decode(
    struct ordering_bar_t *self_p,
    const uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_decode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_decode_inner_t)ordering_bar_decode_inner));
}

void ordering_foo_init(
    struct ordering_foo_t *self_p,
    struct pbtools_heap_t *heap_p,
    struct ordering_foo_t *next_p)
{
    self_p->base.heap_p = heap_p;
    self_p->base.next_p = &next_p->base;
    ordering_bar_init(&self_p->bar, heap_p, NULL);
    self_p->fam = 0;
}

void ordering_foo_encode_inner(
    struct pbtools_encoder_t *encoder_p,
    struct ordering_foo_t *self_p)
{
    pbtools_encoder_write_enum(encoder_p, 2, self_p->fam);
    pbtools_encoder_sub_message_encode(
        encoder_p,
        1,
        &self_p->bar.base,
        (pbtools_message_encode_inner_t)ordering_bar_encode_inner);
}

void ordering_foo_decode_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_foo_t *self_p)
{
    int wire_type;

    while (pbtools_decoder_available(decoder_p)) {
        switch (pbtools_decoder_read_tag(decoder_p, &wire_type)) {

        case 1:
            pbtools_decoder_sub_message_decode(
                decoder_p,
                wire_type,
                &self_p->bar.base,
                (pbtools_message_decode_inner_t)ordering_bar_decode_inner);
            break;

        case 2:
            self_p->fam = pbtools_decoder_read_enum(decoder_p, wire_type);
            break;

        default:
            pbtools_decoder_skip_field(decoder_p, wire_type);
            break;
        }
    }
}

void ordering_foo_encode_repeated_inner(
    struct pbtools_encoder_t *encoder_p,
    int field_number,
    struct ordering_foo_repeated_t *repeated_p)
{
    pbtools_encode_repeated_inner(
        encoder_p,
        field_number,
        (struct pbtools_repeated_message_t *)repeated_p,
        (pbtools_message_encode_inner_t)ordering_foo_encode_inner);
}

void ordering_foo_decode_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    int wire_type,
    struct ordering_foo_repeated_t *repeated_p)
{
    pbtools_decode_repeated_inner(
        decoder_p,
        wire_type,
        (struct pbtools_repeated_message_t *)repeated_p,
        sizeof(struct ordering_foo_t),
        (pbtools_message_init_t)ordering_foo_init,
        (pbtools_message_decode_inner_t)ordering_foo_decode_inner);
}

void ordering_foo_finalize_repeated_inner(
    struct pbtools_decoder_t *decoder_p,
    struct ordering_foo_repeated_t *repeated_p)
{
    pbtools_finalize_repeated_inner(
        decoder_p,
        (struct pbtools_repeated_message_t *)repeated_p);
}

struct ordering_foo_t *
ordering_foo_new(
    void *workspace_p,
    size_t size)
{
    return (pbtools_message_new(
                workspace_p,
                size,
                sizeof(struct ordering_foo_t),
                (pbtools_message_init_t)ordering_foo_init));
}

int ordering_foo_encode(
    struct ordering_foo_t *self_p,
    uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_encode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_encode_inner_t)ordering_foo_encode_inner));
}

int ordering_foo_decode(
    struct ordering_foo_t *self_p,
    const uint8_t *encoded_p,
    size_t size)
{
    return (pbtools_message_decode(
                &self_p->base,
                encoded_p,
                size,
                (pbtools_message_decode_inner_t)ordering_foo_decode_inner));
}
